# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'ListJobEnvSecretsResult',
    'AwaitableListJobEnvSecretsResult',
    'list_job_env_secrets',
    'list_job_env_secrets_output',
]

@pulumi.output_type
class ListJobEnvSecretsResult:
    """
    Secret environment variable collection.
    """
    def __init__(__self__, value=None):
        if value and not isinstance(value, list):
            raise TypeError("Expected argument 'value' to be a list")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def value(self) -> Sequence['outputs.SecretResponse']:
        """
        Collection of resources.
        """
        return pulumi.get(self, "value")


class AwaitableListJobEnvSecretsResult(ListJobEnvSecretsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListJobEnvSecretsResult(
            value=self.value)


def list_job_env_secrets(job_name: Optional[str] = None,
                         resource_group_name: Optional[str] = None,
                         service_name: Optional[str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListJobEnvSecretsResult:
    """
    List sensitive environment variables of the Job.
    Azure REST API version: 2024-05-01-preview.


    :param str job_name: The name of the Job resource.
    :param str resource_group_name: The name of the resource group that contains the resource. You can obtain this value from the Azure Resource Manager API or the portal.
    :param str service_name: The name of the Service resource.
    """
    __args__ = dict()
    __args__['jobName'] = job_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['serviceName'] = service_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:appplatform:listJobEnvSecrets', __args__, opts=opts, typ=ListJobEnvSecretsResult).value

    return AwaitableListJobEnvSecretsResult(
        value=pulumi.get(__ret__, 'value'))


@_utilities.lift_output_func(list_job_env_secrets)
def list_job_env_secrets_output(job_name: Optional[pulumi.Input[str]] = None,
                                resource_group_name: Optional[pulumi.Input[str]] = None,
                                service_name: Optional[pulumi.Input[str]] = None,
                                opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[ListJobEnvSecretsResult]:
    """
    List sensitive environment variables of the Job.
    Azure REST API version: 2024-05-01-preview.


    :param str job_name: The name of the Job resource.
    :param str resource_group_name: The name of the resource group that contains the resource. You can obtain this value from the Azure Resource Manager API or the portal.
    :param str service_name: The name of the Service resource.
    """
    ...
